package com.logicbig.example;

import com.fasterxml.jackson.databind.ObjectMapper;
import java.io.IOException;
import java.util.List;

public class ExampleMain2 {

    public static void main(String[] args) throws IOException {
        Employee emp = new Employee();
        emp.setEmpId(1);

        Dept dept1 = new Dept();
        dept1.setDeptId(3);
        dept1.setEmployees(List.of(emp));

        Dept dept2 = new Dept();
        dept2.setDeptId(4);
        dept2.setEmployees(List.of(emp));

        System.out.println("-- before serializing --");
        System.out.println(emp);

        System.out.println("-- json string after serializing --");
        ObjectMapper om = new ObjectMapper();
        String s = om.writeValueAsString(emp);
        System.out.println(s);
        System.out.println("-- deserializing --");
        Employee employee = om.readValue(s, Employee.class);
        System.out.println(employee);
        System.out.println("-- deserialized back references --");
        for (Dept dept : employee.getDepts()) {
            System.out.println(dept + " -> " + dept.getEmployees());
        }
    }
}